'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _makeRequest = require('./makeRequest.js');

Object.defineProperty(exports, 'makeRequest', {
  enumerable: true,
  get: function get() {
    return _makeRequest.makeRequest;
  }
});
var waitUntilEvent = exports.waitUntilEvent = function waitUntilEvent(name) {
  var $el = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : document;
  return new Promise(function (resolve) {
    var handleEvent = function handleEvent() {
      $el.removeEventListener(name, handleEvent);
      resolve();
    };
    $el.addEventListener(name, handleEvent);
  });
};

var waitUntilTagIsAppended = exports.waitUntilTagIsAppended = function waitUntilTagIsAppended(name, $el) {
  return new Promise(function (resolve) {
    var observer = void 0;

    var handleMutations = function handleMutations(mutations) {
      mutations.forEach(function (mutation) {
        var $child = Array.from(mutation.addedNodes).find(function (node) {
          return node.tagName && node.tagName.toLowerCase() === name;
        });

        if ($child != null) {
          observer.disconnect();
          resolve($child);
        }
      });
    };

    observer = new MutationObserver(handleMutations);

    observer.observe($el, {
      childList: true,
      subtree: true
    });
  });
};

var registerComponent = exports.registerComponent = function registerComponent(name, DefinitionClass) {
  if (window.customElements.get(name) == null) {
    window.customElements.define(name, DefinitionClass);
  }
};