"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var defaultStatusChecker = function defaultStatusChecker(response) {
  return response.ok;
};

var defaultResponseParser = function defaultResponseParser(response) {
  return response.json();
};

var defaultBodyParser = function defaultBodyParser(body) {
  return JSON.stringify(body);
};

var defaultErrorHandler = function defaultErrorHandler(error) {
  return error;
};

var makeRequest = exports.makeRequest = function makeRequest(url) {
  var requestParams = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var requestConfig = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var fetchMaker = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : fetch;
  var _requestConfig$status = requestConfig.statusChecker,
      statusChecker = _requestConfig$status === undefined ? defaultStatusChecker : _requestConfig$status,
      _requestConfig$respon = requestConfig.responseParser,
      responseParser = _requestConfig$respon === undefined ? defaultResponseParser : _requestConfig$respon,
      _requestConfig$bodyPa = requestConfig.bodyParser,
      bodyParser = _requestConfig$bodyPa === undefined ? defaultBodyParser : _requestConfig$bodyPa,
      _requestConfig$errorH = requestConfig.errorHandler,
      errorHandler = _requestConfig$errorH === undefined ? defaultErrorHandler : _requestConfig$errorH;
  var body = requestParams.body;

  var requestParamsWithParsedBody = requestParams;

  if (body != null) {
    requestParamsWithParsedBody = _extends({}, requestParams, {
      body: bodyParser(body)
    });
  }

  return fetchMaker(url, requestParamsWithParsedBody).then(function (response) {
    if (statusChecker(response) === true) {
      return responseParser(response);
    }
    throw errorHandler(response);
  }).catch(function (error) {
    throw errorHandler(error);
  });
};