'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var isValidCNPJ = exports.isValidCNPJ = function isValidCNPJ() {
  var arg = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : '';

  var strCNPJ = arg;

  var size = void 0;
  var numbers = void 0;
  var sum = void 0;
  var pos = void 0;
  var result = void 0;

  strCNPJ = strCNPJ.replace(/\D/g, '');

  if (strCNPJ === '') {
    return false;
  }

  if (strCNPJ.length !== 14) {
    return false;
  }

  if (strCNPJ === '00000000000000' || strCNPJ === '11111111111111' || strCNPJ === '22222222222222' || strCNPJ === '33333333333333' || strCNPJ === '44444444444444' || strCNPJ === '55555555555555' || strCNPJ === '66666666666666' || strCNPJ === '77777777777777' || strCNPJ === '88888888888888' || strCNPJ === '99999999999999') {
    return false;
  }

  size = strCNPJ.length - 2;
  numbers = strCNPJ.substring(0, size);
  var digits = strCNPJ.substring(size);

  sum = 0;
  pos = size - 7;

  for (var i = size; i >= 1; i -= 1) {
    sum += numbers.charAt(size - i) * pos;
    pos -= 1;

    if (pos < 2) {
      pos = 9;
    }
  }

  result = sum % 11 < 2 ? 0 : 11 - sum % 11;

  if (String(result) !== digits.charAt(0)) {
    return false;
  }

  size += 1;
  numbers = strCNPJ.substring(0, size);
  sum = 0;
  pos = size - 7;

  for (var _i = size; _i >= 1; _i -= 1) {
    sum += numbers.charAt(size - _i) * pos;
    pos -= 1;

    if (pos < 2) {
      pos = 9;
    }
  }

  result = sum % 11 < 2 ? 0 : 11 - sum % 11;

  if (String(result) !== digits.charAt(1)) {
    return false;
  }

  return true;
};