'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var validate = exports.validate = function validate(scope, formdata) {
  return {
    with: function _with(validators, errorMaker) {
      var values = void 0;
      var isValid = void 0;

      if (Array.isArray(scope)) {
        values = Object.entries(formdata).filter(function (_ref) {
          var _ref2 = _slicedToArray(_ref, 1),
              key = _ref2[0];

          return scope.includes(key);
        }).map(function (_ref3) {
          var _ref4 = _slicedToArray(_ref3, 2),
              value = _ref4[1];

          return value;
        });
      } else if (typeof scope === 'string') {
        values = formdata[scope];
      } else {
        values = Object.values(formdata);
      }

      if (Array.isArray(validators)) {
        isValid = validators.every(function (validator) {
          return validator(values);
        });
      } else if (typeof validators === 'function') {
        isValid = validators(values);
      } else {
        isValid = false;
      }

      var target = typeof scope === 'string' ? scope : undefined;

      var error = typeof errorMaker === 'string' ? errorMaker : errorMaker(scope, formdata);

      return {
        isValid: isValid,
        target: target,
        error: isValid ? undefined : error
      };
    }
  };
};