'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.formatDateRange = exports.formatTime = exports.formatDate = exports.formatCurrencyWithoutSymbol = exports.formatCurrency = exports.defaultSdkCallDateFormat = undefined;

var _momentBundle = require('../lib/moment.bundle.js');

var _momentBundle2 = _interopRequireDefault(_momentBundle);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var defaultSdkCallDateFormat = exports.defaultSdkCallDateFormat = 'YYYY-MM-DD';

var modelDate = function modelDate(date) {
  return (0, _momentBundle2.default)(date).utc().format('DD/MM/YYYY');
};
var modelTime = function modelTime(date) {
  return '' + (0, _momentBundle2.default)(date).utc().format('HH:mm');
};

var locale = 'pt-BR';

var formatCurrency = exports.formatCurrency = function formatCurrency(string) {
  return Number(string).toLocaleString('pt-BR', {
    style: 'currency', currency: 'BRL'
  });
};

var formatCurrencyWithoutSymbol = exports.formatCurrencyWithoutSymbol = function formatCurrencyWithoutSymbol(value) {
  return value.toLocaleString(locale, { minimumFractionDigits: 2, maximumFractionDigits: 2 });
};

var formatDate = exports.formatDate = function formatDate(item) {
  return modelDate(item);
};
var formatTime = exports.formatTime = function formatTime(item) {
  return modelTime(item);
};

var formatDateRange = exports.formatDateRange = function formatDateRange(startDate, finalDate) {
  return formatDate(startDate) + ' \u2013 ' + formatDate(finalDate);
};