var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

const defaultStatusChecker = response => response.ok;

const defaultResponseParser = response => response.json();

const defaultBodyParser = body => JSON.stringify(body);

const defaultErrorHandler = error => error;

export const makeRequest = (url, requestParams = {}, requestConfig = {}, fetchMaker = fetch) => {
  const {
    statusChecker = defaultStatusChecker,
    responseParser = defaultResponseParser,
    bodyParser = defaultBodyParser,
    errorHandler = defaultErrorHandler
  } = requestConfig;

  const { body } = requestParams;
  let requestParamsWithParsedBody = requestParams;

  if (body != null) {
    requestParamsWithParsedBody = _extends({}, requestParams, {
      body: bodyParser(body)
    });
  }

  return fetchMaker(url, requestParamsWithParsedBody).then(response => {
    if (statusChecker(response) === true) {
      return responseParser(response);
    }
    throw errorHandler(response);
  }).catch(error => {
    throw errorHandler(error);
  });
};